<template>
  <div>
    <el-form ref="queryForm" :model="searchForm" label-width="0" inline @submit.prevent>
      <el-form-item>
        <el-input
          v-model="searchForm.name"
          placeholder="请输入名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
        <el-button type="primary" @click="openForm('create', null)">新增</el-button>
      </el-form-item>
    </el-form>
    <el-table v-loading="loading" :data="list">
      <el-table-column prop="name" label="品牌名称" />
      <el-table-column prop="sort" label="排序" width="100px" />
      <el-table-column prop="description" label="备注" />
      <el-table-column label="开启状态" prop="status">
        <template #default="scope">
          <dict-tag :type="DICT_TYPE.COMMON_STATUS" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column
        label="创建时间"
        prop="createTime"
        width="180px"
        :formatter="dateFormatter"
      />
      <el-table-column label="操作">
        <template #default="scope">
          <el-button type="primary" text @click="openForm('update', scope.row.brandId)"
            >修改</el-button
          >
          <el-button type="danger" text @click="handleDelete(scope.row.brandId)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <Pagination
      v-model:limit="searchForm.pageSize"
      v-model:page="searchForm.pageNo"
      :total="total"
      @pagination="handleQuery"
    />

    <DialogBrand ref="brandDialog" @success="handleQuery" />
  </div>
</template>

<script setup name="BrandSet">
import { DICT_TYPE } from '@/utils/dict'
import { dateFormatter } from '@/utils/formatTime'
import * as ProductBrandApi from '@/api/mall/product/brand'
import DialogBrand from './DialogBrand.vue'

const message = useMessage() // 消息弹窗
const { t } = useI18n() // 国际化

const searchForm = ref({
  name: undefined,
  pageNo: 1,
  pageSize: 20
})

const total = ref(0)
const brandDialog = ref()
const list = ref([])
const loading = ref(false)

function handleQuery() {
  searchForm.value.pageNo = 1
  getList()
}
function resetQuery() {
  searchForm.value = {
    name: '',
    pageSize: 20,
    pageNo: 1
  }
  getList()
}

async function getList() {
  loading.value = true
  try {
    const data = await ProductBrandApi.getBrandParam(searchForm.value)
    list.value = data.list
    total.value = data.total
  } finally {
    loading.value = false
  }
}

function openForm(type, id) {
  brandDialog.value.open(type, id)
}

async function handleDelete(id) {
  try {
    // 删除的二次确认
    await message.delConfirm()
    // 发起删除
    await ProductBrandApi.deleteBrand(id)
    message.success(t('common.delSuccess'))
    // 刷新列表
    await getList()
  } catch (err) {
    console.log(err)
  }
}

onMounted(() => {
  handleQuery()
})
</script>

<style lang="scss" scoped></style>
